"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.gotoLocation = void 0;
const vscode_languageserver_protocol_1 = require("vscode-languageserver-protocol");
const conversions_1 = require("../utils/conversions");
const editor_1 = require("../utils/editor");
// Go to the location if it's in the same text document.
// Otherwise, let the app handle it.
// TODO Support Peek
exports.gotoLocation = (cm, uri, location) => {
    // TODO Let user pick if there are multiple locations
    const loc = Array.isArray(location) ? location[0] : location;
    if (vscode_languageserver_protocol_1.Location.is(loc)) {
        if (loc.uri === uri) {
            const newPos = conversions_1.cmPosition(loc.range.start);
            editor_1.highlightRange(cm, ...conversions_1.cmRange(loc.range), 1500);
            // @ts-ignore @types/codemirror doesn't allow `setCursor(pos, options)`
            cm.setCursor(newPos, { scroll: true });
            // TODO Figure out why the editor loses focus when triggered from context menu
            cm.focus();
        }
        else {
            // this.showTextDocument(loc.uri, loc.range);
            // console.log(loc);
        }
    }
    else if (vscode_languageserver_protocol_1.LocationLink.is(loc)) {
        // Returned with client capability: textDocument.*.linkSupport
        if (loc.targetUri === uri) {
            const newPos = conversions_1.cmPosition(loc.targetSelectionRange.start);
            editor_1.highlightRange(cm, ...conversions_1.cmRange(loc.targetRange), 1500);
            // @ts-ignore @types/codemirror doesn't allow `setCursor(pos, options)`
            cm.setCursor(newPos, { scroll: true });
            // TODO Figure out why the editor loses focus when triggered from context menu
            cm.focus();
        }
        else {
            // this.showTextDocument(loc.targetUri, loc.targetSelectionRange);
            // console.log(loc);
        }
    }
};
//# sourceMappingURL=goto.js.map