/// <reference types="codemirror/addon/hint/show-hint" />
import type { Editor } from "codemirror";
import type { CompletionItem, CompletionList, CancellationToken } from "vscode-languageserver-protocol";
import { LspConnection } from "@qualified/lsp-connection";
export declare type CompletionHandlerOptions = {
    uri: string;
    editor: Editor;
    conn: LspConnection;
    renderMarkdown: (x: string) => string;
};
export declare class CompletionHandler {
    private uri;
    private editor;
    private conn;
    private pendingRequest;
    private renderMarkdown;
    constructor({ uri, editor, conn, renderMarkdown }: CompletionHandlerOptions);
    invoke(): void;
    private retriggerForIncomplete;
    private triggerWith;
    /**
     * Attempt to start/resume completion on `change` event.
     *
     * @returns true if handled.
     */
    onChange(): boolean;
    private request;
    /**
     * Close completion popup.
     */
    close(): void;
    /**
     * True if completion is active.
     */
    private isActive;
    /**
     * True if completion is active, and the completion list is complete.
     * There's no need to make new requests.
     */
    private isComplete;
    private cancelPending;
}
export declare type CompletionHintOptions = {
    editor: Editor;
    list: CompletionList;
    invoked: boolean;
    renderMarkdown: (x: string) => string;
    resolveItem: (item: CompletionItem, token?: CancellationToken) => Promise<CompletionItem>;
};
