export interface TypeaheadItem {
    label: string;
}
export interface TypeaheadOptions<T extends TypeaheadItem> {
    getSuggestions: (this: void, text: string) => Promise<T[]>;
    onSelect: (this: void, item: T) => void;
    onUpdate?: (this: void, current: T) => void;
    onCancel?: (this: void) => void;
    render?: (this: void, item: T, value: string) => HTMLDivElement | undefined;
    className?: string;
    debounceTimeout?: number;
}
export declare type Disposer = () => void;
export declare const attachTypeahead: <T extends TypeaheadItem>(input: HTMLInputElement, { getSuggestions, onSelect, onUpdate, onCancel, render, className, debounceTimeout, }: TypeaheadOptions<T>) => Disposer;
